/**
 * 页面加载初始化
 */
$(document).ready(function() {
	loadUE();
	loadToolbar();
	loadSearch();
	loadData();
});

/**
 * 加载页面布局
 */
function loadUE() {
	new MxtLayout({
		'id' : 'layout',
		'northArea' : {
			'id' : 'north',
			'height' : 40,
			'sprit' : false,
			'border' : false
		},
		'centerArea' : {
			'id' : 'center',
			'border' : false,
			'minHeight' : 20
		}
	});
}

function loadToolbar() {
	var toolbarArray = new Array();
	//新建
	toolbarArray.push({
		id : "newMarkBtn",
		name : $.i18n('common.toolbar.new.label'),
		className : "ico16",
		click : createMarkDef
	});
	//修改
	toolbarArray.push({
		id : "updateMarkBtn",
		name : $.i18n('common.toolbar.update.label'),
		className : "ico16 editor_16",
		click : editMarkDef
	});
	//删除
	toolbarArray.push({
		id : "delMarkBtn",
		name : $.i18n('common.button.delete.label'),
		className : "ico16 del_16",
		click : deleteMarkDef
	});
	//预留文号
	var subMenus =  new Array(); 
	subMenus.push({id : "reserveUpBtn", name : dialogTitleUp, className : "ico16 reserve_16", click : function() { reserveMark(1);} });
	subMenus.push({id : "reserveDownBtn", name : dialogTitleDown, className : "ico16 reserve_16", click : function() { reserveMark(2);} });
	toolbarArray.push({
		id : "reserveMarkBtn",
		name : dialogTitleUp + $.i18n('govdoc.mark.reserve.set'),
		className : "ico16 reserve_16",
		subMenu : subMenus
	});
	
	// 工具栏
	$("#toolbars").toolbar({
		toolbar : toolbarArray
	});
}


/**
 * 加载列表小查询
 */
var searchobj;
var topSearchSize = 7;
function loadSearch() {
	var conditionArray = new Array();
	// 当前文号
	conditionArray.push({
		id : 'markstr',
		name : 'markstr',
		type : 'input',
		text : $.i18n("govdoc.docmark.current"),
		value : 'markstr',
		maxLength : 100
	});
	var subMenuArr = new Array();
	subMenuArr.push({"text":$.i18n("govdoc.document.number"), "value":"0"});
	subMenuArr.push({"text":$.i18n("govdoc.Internal.document.number"), "value":"1"});
	subMenuArr.push({"text":$.i18n("govdoc.signMark.label"), "value":"2"});
	// 文号类型
	conditionArray.push({
		id : 'markType',
		name : 'markType',
		type : 'select',
		text : $.i18n("govdoc.element.wordno.type"),
		value : 'markType',
		dateTime : false,
		items : subMenuArr
	});
	// 预留文号
	conditionArray.push({
		id : 'markReserveUp',
		name : 'markReserveUp',
		type : 'input',
		text : dialogTitleUp,
		value : 'markReserveUp',
		maxLength : 100
	});
	// 线下占用
	conditionArray.push({
		id : 'markReserveDown',
		name : 'markReserveDown',
		type : 'input',
		text : dialogTitleDown,
		value : 'markReserveDown'
	});
	
	searchobj = $.searchCondition({
		top : topSearchSize,
		right : 10,
		searchHandler : function() {
			var o = getConditionObj();
			if(o) {
				o.page = 1;
				searchByCondition(o);	
			}
		},
		conditions : conditionArray
	});
}

function getConditionObj() {
	var o = new Object();
	var choose = $('#' + searchobj.p.id).find("option:selected").val();
	if (choose == 'markstr') {// 当前文号
		o.markstr = $('#markstr').val();
	} else if (choose == 'markType') {// 文号类型
		o.markType = $('#markType').val();
	} else if (choose == 'markReserveUp') {// 预留文号
		o.markReserveUp = $('#markReserveUp').val();
	} else if (choose == 'markReserveDown') {// 线下占用
		o.markReserveDown = $('#markReserveDown').val();
	}
	o.condition = "choose";
	return o;
}

/**
 * 重新加载列表
 */
function searchByCondition(o) {
    $("#markList").ajaxgridLoad(o);
}

var grid;
function loadData() {
	var colModels = new Array();
	colModels.push({
		display : 'markDefId',
		name : 'markDefId',
		value : 'markDefId',
		domainId : 'domainId',
		width : '4%',
		type : 'checkbox',
		isToggleHideShow : false
	});
	// 当前文号
	colModels.push({
		display : $.i18n("govdoc.docmark.current"),
		name : 'markstr',
		sortable : true,
		width : '20%'
	});
	// 文号类型
	colModels.push({
		display : $.i18n("govdoc.element.wordno.type"),
		name : 'markType',
		sortable : true,
		width : '10%'
	});
	// 预留文号
	colModels.push({
		display : $.i18n("govdoc.mark.reserve.up"),
		name : 'markReserveUp',
		sortable : true,
		width : '19%'
	});
	// 线下占用文号
	colModels.push({
		display : $.i18n("govdoc.mark.reserve.down.label"),
		name : 'markReserveDown',
		sortable : true,
		width : '19%'
	});
	// 授权
	colModels.push({
		display : $.i18n("govdoc.docmark.grantdepart"),
		name : 'aclEntityName',
		sortable : true,
		width : '20%'
	});
	// 排序号
	colModels.push({
		display : $.i18n("govdoc.queue.number"),
		name : 'sortNo',
		sortable : true,
		width : '5%'
	});

	//构造列表
    grid = $('#markList').ajaxgrid({
       click: clickRow,
       dblclick: dbclickRow,
       colModel: colModels,
       height: 200,
       render : rend,
       showTableToggleBtn: true,
       parentId: $('.layout_center').eq(0).attr('id'),
       vChange: true,
       isHaveIframe:true,
       slideToggleBtn:true,
       onSuccess:function() {
       		loadDesc();
       },
       managerName : "govdocMarkManager",
       managerMethod : "findList"
   });
}

function loadDesc(url, updown) {
	if($.trim(grid) != "" && $.trim(grid.p) != "") {
		if(!url) {
		    //客开 项目名称： [修改功能：] 作者：fzc 修改日期：2018-4-25 start
			//url = edocMarkURL + "?method=listDesc&size="+grid.p.total;
            url = "";
            //客开 项目名称： [修改功能：] 作者：fzc 修改日期：2018-4-25 end
		} else {
			updown = "middle";
		}
		if(!updown) {
			updown = "down";
		}
		grid.grid.resizeGridUpDown(updown);
	}
	$('#summary').attr("src", url);
}

function rend(txt, data, r, c, col) {
	if (null == txt) {
		txt = "";
	}
	if (col.name === "markType") {// 文号类型
		if(data.markType == "0") {
			txt = $.i18n("govdoc.docMark.label");	
		} else if(data.markType == "1") {
			txt = $.i18n("govdoc.serialNo.label");	
		} else {
			txt = $.i18n("govdoc.signMark.label");
		}
	}
	return txt;
}

function clickRow(data, rowIndex, colIndex) {
	editMarkDef("readonly", data.markDefId, data.domainId);
}

function dbclickRow(data, rowIndex, colIndex) {
	editMarkDef("edit", data.markDefId, data.domainId);
}

/**
 * 公文应用设置-文号管理列表-新建
 */
function createMarkDef() {
	loadDesc(edocMarkURL + "?method=createMarkDef");
}

/**
 * 公文应用设置-文号管理列表-编辑
 */
function editMarkDef(flag, markDefId, domainId) {
	if(!markDefId) {
		var rows = grid.grid.getSelectRows();
		if(rows.length == 0) {
			alert(v3x.getMessage("edocLang.doc_mark_alter_select_deleted"));
			return ;
		} else if(rows.length > 1) {
			alert(v3x.getMessage("edocLang.doc_mark_alter_select_one"));
			return ;
		}
		flag = "edit";
		markDefId = rows[0].markDefId;
		domainId = rows[0].domainId;
	}
	if(flag == "edit") {
		if(domainId != $("#orgAccountId").val()) {
			alert(v3x.getMessage("edocLang.doc_mark_alter_not_edit"));
  			return;
		}
	}
	
	var aUrl = edocMarkURL + "?method=editMarkDef&flag=" + flag + "&id=" + markDefId;
	loadDesc(aUrl);
}

/**
 * 公文应用设置-文号管理列表-删除
 */
function deleteMarkDef() {
	var rows = grid.grid.getSelectRows();
	if(rows.length == 0) {
		alert(v3x.getMessage("edocLang.doc_mark_alter_select_deleted"));
		return ;
	}
	
	var mainForm = document.getElementById("mainForm");
	mainForm.innerHTML = "";

	var isOwerDomain = true;
	for(var i=0; i<rows.length; i++) {
		var _this = rows[i];
		var markDefId = _this.markDefId;
		var domainId = _this.domainId;
		if(domainId != $("#orgAccountId").val()) {
			isOwerDomain = false;
  			break;
		}
  		mainForm.innerHTML += "<input type=hidden name=markDefId value=" + markDefId + ">";
	}
	if(!isOwerDomain) {
		alert(v3x.getMessage("edocLang.doc_mark_alter_not_delete"));
		return;
	}
	if(window.confirm(v3x.getMessage("govdocLang.doc_mark_alter_delete_confirm"))){
		$(mainForm).attr("target", "formIframe");
		$(mainForm).attr("method", "post");
		$(mainForm).attr("action", edocMarkURL + "?method=deleteMarkDef");
		$(mainForm).submit();
	}
}

//预留文号
function reserveMark(type) {
	var rows = grid.grid.getSelectRows();
	if(rows.length == 0) {
		alert(v3x.getMessage("edocLang.doc_mark_alter_select_deleted"));
		return ;
	} else if(rows.length > 1) {
		if(type == 1) {
			alert(v3x.getMessage("edocLang.doc_mark_alter_select_one_to_reserve_up"));//只能选择一个公文文号设置预留文号！
		} else {
			alert(v3x.getMessage("edocLang.doc_mark_alter_select_one_to_reserve_down"));//只能选择一个公文文号设置线下占用文号
		}
		return;
	}
	var markObj = rows[0];
	if(markObj.domainId != $("#orgAccountId").val()) {
		if(type == 1) {
			alert(v3x.getMessage("edocLang.doc_mark_outer_reserved_up_not_set"));//此公文文号使用的大流水进行编号，暂不支持设置预留文号！
		} else {
			alert(v3x.getMessage("edocLang.doc_mark_outer_reserved_down_not_set"));//此公文文号使用的大流水进行编号，暂不支持设置线下占用文号！
		}
		return;
	}
	
	var requestCaller = new XMLHttpRequestCaller(this, "govdocMarkManager", "checkExistMarkDef", false);
	requestCaller.addParameter(1, "String", markObj.markDefId);
	var rs = requestCaller.serviceRequest();
	if(rs=='false') {
		alert(v3x.getMessage("edocLang.doc_mark_definition_alter_deleted"));//公文文号已被删除
		window.location.reload();
    	return false;
    }
	var dialogTitle = dialogTitleUp;
	if(type == 2) {
		dialogTitle = dialogTitleDown;
	}
	getCtpTop().win123 = $.dialog({
		title: dialogTitle,
		targetWindow : getCtpTop(),
		transParams : {
		},
		transParams: { 'parentWin':window },
        url: edocMarkURL + "?method=openReserveDialog&markDefId="+markObj.markDefId+"&type="+type,
        width: 800,
        height: 350,
        resizable: true
    });
}

//刷新父页面
function reloadList() {
	var listObj = $("#markList");
    if(listObj[0])  {//如果从列表中打开，则刷新列表
    	try {
    		searchByCondition(new Object());
    		loadDesc();
    	} catch(e) {
    		location.href = edocMarkUrl + "?method=list";	
    	}
    } else {
    	location.href = edocMarkUrl + "?method=list";
    }
	//location.reload();
}
